package meerkat.Registry;

import meerkat.MessageValidator;
import meerkat.VoterRegistry;
import meerkat.bulletinboard.BulletinBoardClient.ClientCallback;

/**
 * TODO: add logging
 */

/**
 * Created by Vladimir Eliezer Tokarev  on 2/19/2016.
 * Handles the the after post state of VoterRegistry methods (that uses bulletinBoardClient to communicate with the server)
 */
public class BooleanCallBack implements ClientCallback<Boolean>, MessageValidator<Boolean> {
    public VoterRegistry.RegistryCallBack callback;

    /**
     * Init BooleanCallBack
     * @param callback  voter registry callback object
     */
    public BooleanCallBack(VoterRegistry.RegistryCallBack callback) {
        this.callback = callback;
    }

    /**
     * Calls the callback HandleResult method with passed object from bulletinBoardClient
     * @param msg the message that the bulletinBoardClient passes to the callback
     */
    @Override
    public void handleCallback(Boolean msg) {
        callback.HandleResult(msg);
    }

    /**
     * Calls the callback HandleResult method with false because the post method failed
     * @param t the exception data that have been thrown during the failure of the post method
     */
    @Override
    public void handleFailure(Throwable t) {
        callback.HandleFailure(t);
    }

    /**
     * always return true because there no n
     * @param object object which will be checked
     * @return alwyas true
     * @throws ValidationError
     */
    @Override
    public Boolean validate(Boolean object) throws ValidationError {
        return true;
    }
}
